// Generated by CoffeeScript 2.1.1
(function() {
  var data, getChannels, getUsers, listToHash, request;

  request = require('request');

  listToHash = function(list, keyName, innerKey) {
    var hash, i, item, len;
    list = list[keyName];
    hash = {};
    for (i = 0, len = list.length; i < len; i++) {
      item = list[i];
      if (innerKey != null) {
        hash[item.id] = item[innerKey];
      } else {
        hash[item.id] = item;
      }
    }
    return hash;
  };

  data = {};

  getUsers = function(token) {
    return request.get({
      url: `https://slack.com/api/users.list?token=${token}`,
      json: true
    }, function(err, res, users) {
      if (err) {
        throw err;
      }
      data['users.simple'] = listToHash(users, "members", "name");
      return data['users'] = listToHash(users, "members");
    });
  };

  getChannels = function(token) {
    return request.get({
      url: `https://slack.com/api/channels.list?token=${token}`,
      json: true
    }, function(err, res, channels) {
      if (err) {
        throw err;
      }
      data['channels.simple'] = listToHash(channels, "channels", "name");
      return data['channels'] = listToHash(channels, "channels");
    });
  };

  module.exports = function(API_TOKEN, HOOK_URL) {
    if (API_TOKEN != null) {
      getUsers(API_TOKEN);
      getChannels(API_TOKEN);
    }
    return {
      postMessage: function(message, channel, nick, icon, attachments) {
        var messageData;
        messageData = {
          text: message,
          parse: "full",
          attachments: attachments
        };
        if ((icon != null) && (icon.slice(0, 8) === 'https://' || icon.slice(0, 7) === 'http://')) {
          messageData.icon_url = icon;
        // If icon is present and is not an emoji
        } else if ((icon != null) && !icon.match(/^\:\w*\:$/)) {
          messageData.icon_emoji = `:${icon}:`;
        // If icon is present and is an emoji
        } else if ((icon != null) && icon.match(/^\:\w*\:$/)) {
          messageData.icon_emoji = icon;
        }
        if (channel != null) {
          messageData.channel = `#${channel}`;
        }
        if (nick != null) {
          messageData.username = nick;
        }
        return request.post({
          url: HOOK_URL,
          json: messageData
        });
      },
      sendMessage: function(message, to, as) {
        return request.post({
          url: HOOK_URL,
          json: {
            text: message,
            username: as,
            parse: "full",
            channel: `@${to}`
          }
        });
      },
      // exporting this to test the method
      listToHash: listToHash,
      parseMessage: function(message) {
        return message.replace("<!channel>", "@channel").replace("<!group>", "@group").replace("<!everyone>", "@everyone").replace(/<#(C\w*)>/g, function(match, channelId) {
          return `#${data['channels.simple'][channelId]}`;
        }).replace(/<@(U\w*)>/g, function(match, userId) {
          return `@${data['users.simple'][userId]}`;
        }).replace(/<(\S*)>/g, function(match, link) {
          return link;
        }).replace(/http(s)?:\/\/([^\s]*)\|([^\s]*)/g, function(match, protocol, href1, href2) {
          if (href1 === href2) {
            return "http" + (protocol || "") + "://" + href1;
          }
        }).replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
      },
      userInfoById: function(search_id) {
        var id, info, ref;
        ref = data['users'];
        for (id in ref) {
          info = ref[id];
          if (search_id === id) {
            return info;
          }
        }
      },
      userInfoByName: function(username) {
        var id, info, ref;
        ref = data['users'];
        for (id in ref) {
          info = ref[id];
          if (info['name'] === username) {
            return info;
          }
        }
      }
    };
  };

}).call(this);
